var undoClosedButt = {
  populateUndoSubmenu: function(aNode) {
    // remove existing menu items
    while (aNode.hasChildNodes())
      aNode.removeChild(aNode.firstChild);

    // get closed-tabs from nsSessionStore
    var ss = Cc["@mozilla.org/browser/sessionstore;1"].
              getService(Ci.nsISessionStore);

    // return if no restorable tabs
    var noHistory = document.getElementById("bundle_undoclosedtabsbutton")
                      .getString("noHistory");
    if (ss.getClosedTabCount(window) == 0) {
      aNode.appendChild(document.createElement("menuitem"));
      aNode.firstChild.setAttribute("label", noHistory);
      aNode.firstChild.setAttribute("disabled", "true");
      return;
    }

    // populate menu
    var undoItems = eval("(" + ss.getClosedTabData(window) + ")");
    for(var i = 0; i < undoItems.length; i++) {
      var m = aNode.appendChild(document.createElement("menuitem"));
      m.setAttribute("label", undoItems[i].title);
      m.setAttribute("value", i);
      m.setAttribute("oncommand", "undoCloseTab(" + i + ");");
    }

    aNode.appendChild(document.createElement("menuseparator"));

    var clearHistoryLabel = document.getElementById("bundle_undoclosedtabsbutton")
                              .getString("clearHistory");
    var mItem = aNode.appendChild(document.createElement("menuitem"));
    mItem.setAttribute("oncommand", "undoClosedButt.clearClosedTabsHistory()");
    mItem.setAttribute("label", clearHistoryLabel);
    mItem.tooltipText = mItem.label;

  },

  clearClosedTabsHistory: function() {
    try {
      var maxUndo = gPrefService.getIntPref("browser.sessionstore.max_tabs_undo");
    } catch(ex) {
      var maxUndo = 10;
      gPrefService.setIntPref("browser.sessionstore.max_tabs_undo", maxUndo);
    }
    //clear close tabs history
    gPrefService.setIntPref("browser.sessionstore.max_tabs_undo", 0);

    //restore maximum undo history pref
    gPrefService.setIntPref("browser.sessionstore.max_tabs_undo", maxUndo);
  },

  showContext: function(aNode, aEvent) {
    if(aEvent.button == 2) {
      var popup = document.getElementById("undoclosedtabsbutton-menu");
      var x = aNode.boxObject.x;
      var y = aNode.boxObject.y + aNode.boxObject.height;
      document.popupNode = aNode;
      popup.showPopup(aNode, x, y, "popup", null, null);
    }
  },

  rightClickMenu: function(aNode, aEvent) {
    if(aEvent.button == 2) {
      var popup = document.getElementById("undoclosedtabsbutton-menu");
      var x = aNode.boxObject.x;
      var y = aNode.boxObject.y + aNode.boxObject.height;
      document.popupNode = aNode;
      popup.showPopup(aNode, x, y, "popup", null, null);
    }
  },

  restartFX: function() {
    var appStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"]
                               .getService(Components.interfaces.nsIAppStartup);
    appStartup.quit(appStartup.eForceQuit | appStartup.eRestart);  
  }

}

window.addEventListener("load", showuctbcontext, false);
function showuctbcontext() {	
document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", onUCTBPopup, false);
}
function onUCTBPopup() {
  var someConditions = !(gContextMenu.isContentSelected ||
                          gContextMenu.onLink ||
                          gContextMenu.onImage ||
                          gContextMenu.onTextInput);

  gContextMenu.showItem("uctb-contextentry", someConditions);
  gContextMenu.showItem("uctb-separator", someConditions);
}

function canQuitApplication() {
  var os=Components.classes["@mozilla.org/observer-service;1"]
   .getService(Components.interfaces.nsIObserverService)
 if(!os)return true
   try{
  var cancelQuit=Components.classes["@mozilla.org/supports-PRBool;1"]
   .createInstance(Components.interfaces.nsISupportsPRBool)
   os.notifyObservers(cancelQuit,"quit-application-requested",null)
 if(cancelQuit.data)
   return false}
     catch(ex){}
     os.notifyObservers(null,"quit-application-granted",null)
   return true
}